<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <title>AdminLTE 3 | Contact</title>

    <!-- Google Font: Source Sans Pro -->
    <link
      rel="stylesheet"
      href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback"
    />
    <!-- Font Awesome -->
    <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css" />
    <!-- Theme style -->
    <link rel="stylesheet" href="dist/css/adminlte.min.css" />
    <link
      rel="stylesheet"
      href="https://cdn.datatables.net/1.13.5/css/dataTables.bootstrap4.min.css"
    />
    <link
      rel="stylesheet"
      href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css"
    />
    <link
      rel="stylesheet"
      href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"
    />
    <!-- daterange picker -->
    <link rel="stylesheet" href="plugins/daterangepicker/daterangepicker.css" />
    <!-- Bootstrap Color Picker -->
    <link
      rel="stylesheet"
      href="plugins/bootstrap-colorpicker/css/bootstrap-colorpicker.min.css"
    />
  </head>
  <body class="hold-transition sidebar-mini">
    <!-- Site wrapper -->
    <div class="wrapper">
      <!-- Navbar -->
      <nav class="main-header navbar navbar-expand navbar-white navbar-light">
        <!-- Left navbar links -->
        <ul class="navbar-nav">
          <li class="nav-item">
            <a class="nav-link" data-widget="pushmenu" href="#" role="button"
              ><i class="fas fa-bars"></i
            ></a>
          </li>
          <li class="nav-item d-none d-sm-inline-block">
            <a href="index3.html" class="nav-link">Home</a>
          </li>
        </ul>

        <!-- Right navbar links -->
        <ul class="navbar-nav ml-auto">
          <!-- Navbar Search -->
          <li class="nav-item">
            <a
              class="nav-link"
              data-widget="navbar-search"
              href="#"
              role="button"
            >
              <i class="fas fa-search"></i>
            </a>
            <div class="navbar-search-block">
              <form class="form-inline">
                <div class="input-group input-group-sm">
                  <input
                    class="form-control form-control-navbar"
                    type="search"
                    placeholder="Search"
                    aria-label="Search"
                  />
                  <div class="input-group-append">
                    <button class="btn btn-navbar" type="submit">
                      <i class="fas fa-search"></i>
                    </button>
                    <button
                      class="btn btn-navbar"
                      type="button"
                      data-widget="navbar-search"
                    >
                      <i class="fas fa-times"></i>
                    </button>
                  </div>
                </div>
              </form>
            </div>
          </li>

          <!-- Messages Dropdown Menu -->
          <li class="nav-item dropdown">
            <a class="nav-link" data-toggle="dropdown" href="#">
              <i class="far fa-comments"></i>
              <span class="badge badge-danger navbar-badge">3</span>
            </a>
            <div class="dropdown-menu dropdown-menu-lg dropdown-menu-right">
              <a href="#" class="dropdown-item">
                <!-- Message Start -->
                <div class="media">
                  <img
                    src="dist/img/user1-128x128.jpg"
                    alt="User Avatar"
                    class="img-size-50 mr-3 img-circle"
                  />
                  <div class="media-body">
                    <h3 class="dropdown-item-title">
                      Brad Diesel
                      <span class="float-right text-sm text-danger"
                        ><i class="fas fa-star"></i
                      ></span>
                    </h3>
                    <p class="text-sm">Call me whenever you can...</p>
                    <p class="text-sm text-muted">
                      <i class="far fa-clock mr-1"></i> 4 Hours Ago
                    </p>
                  </div>
                </div>
                <!-- Message End -->
              </a>
              <div class="dropdown-divider"></div>
              <a href="#" class="dropdown-item">
                <!-- Message Start -->
                <div class="media">
                  <img
                    src="dist/img/user8-128x128.jpg"
                    alt="User Avatar"
                    class="img-size-50 img-circle mr-3"
                  />
                  <div class="media-body">
                    <h3 class="dropdown-item-title">
                      John Pierce
                      <span class="float-right text-sm text-muted"
                        ><i class="fas fa-star"></i
                      ></span>
                    </h3>
                    <p class="text-sm">I got your message bro</p>
                    <p class="text-sm text-muted">
                      <i class="far fa-clock mr-1"></i> 4 Hours Ago
                    </p>
                  </div>
                </div>
                <!-- Message End -->
              </a>
              <div class="dropdown-divider"></div>
              <a href="#" class="dropdown-item">
                <!-- Message Start -->
                <div class="media">
                  <img
                    src="dist/img/user3-128x128.jpg"
                    alt="User Avatar"
                    class="img-size-50 img-circle mr-3"
                  />
                  <div class="media-body">
                    <h3 class="dropdown-item-title">
                      Nora Silvester
                      <span class="float-right text-sm text-warning"
                        ><i class="fas fa-star"></i
                      ></span>
                    </h3>
                    <p class="text-sm">The subject goes here</p>
                    <p class="text-sm text-muted">
                      <i class="far fa-clock mr-1"></i> 4 Hours Ago
                    </p>
                  </div>
                </div>
                <!-- Message End -->
              </a>
              <div class="dropdown-divider"></div>
              <a href="#" class="dropdown-item dropdown-footer"
                >See All Messages</a
              >
            </div>
          </li>
          <!-- Notifications Dropdown Menu -->
          <li class="nav-item dropdown">
            <a class="nav-link" data-toggle="dropdown" href="#">
              <i class="far fa-bell"></i>
              <span class="badge badge-warning navbar-badge">15</span>
            </a>
            <div class="dropdown-menu dropdown-menu-lg dropdown-menu-right">
              <span class="dropdown-item dropdown-header"
                >15 Notifications</span
              >
              <div class="dropdown-divider"></div>
              <a href="#" class="dropdown-item">
                <i class="fas fa-envelope mr-2"></i> 4 new messages
                <span class="float-right text-muted text-sm">3 mins</span>
              </a>
              <div class="dropdown-divider"></div>
              <a href="#" class="dropdown-item">
                <i class="fas fa-users mr-2"></i> 8 friend requests
                <span class="float-right text-muted text-sm">12 hours</span>
              </a>
              <div class="dropdown-divider"></div>
              <a href="#" class="dropdown-item">
                <i class="fas fa-file mr-2"></i> 3 new reports
                <span class="float-right text-muted text-sm">2 days</span>
              </a>
              <div class="dropdown-divider"></div>
              <a href="#" class="dropdown-item dropdown-footer"
                >See All Notifications</a
              >
            </div>
          </li>
          <li class="nav-item">
            <a class="nav-link" data-widget="fullscreen" href="#" role="button">
              <i class="fas fa-expand-arrows-alt"></i>
            </a>
          </li>
          <li class="nav-item">
            <a
              class="nav-link"
              data-widget="control-sidebar"
              data-slide="true"
              href="#"
              role="button"
            >
              <i class="fas fa-th-large"></i>
            </a>
          </li>
        </ul>
      </nav>
      <!-- /.navbar -->

      <!-- Main Sidebar Container -->
      <aside class="main-sidebar sidebar-dark-primary elevation-4">
        <!-- Brand Logo -->
        <a href="index3.html" class="brand-link">
          <img
            src="dist/img/AdminLTELogo.png"
            alt="AdminLTE Logo"
            class="brand-image img-circle elevation-3"
            style="opacity: 0.8"
          />
          <span class="brand-text font-weight-light">Devcamp</span>
        </a>

        <!-- Sidebar -->
        <div class="sidebar">
          <!-- Sidebar user (optional) -->
          <div class="user-panel mt-3 pb-3 mb-3 d-flex">
            <div class="image">
              <img
                src="dist/img/user2-160x160.jpg"
                class="img-circle elevation-2"
                alt="User Image"
              />
            </div>
            <div class="info">
              <a href="#" class="d-block">Quoc Bao</a>
            </div>
          </div>

          <!-- SidebarSearch Form -->
          <div class="form-inline">
            <div class="input-group" data-widget="sidebar-search">
              <input
                class="form-control form-control-sidebar"
                type="search"
                placeholder="Search"
                aria-label="Search"
              />
              <div class="input-group-append">
                <button class="btn btn-sidebar">
                  <i class="fas fa-search fa-fw"></i>
                </button>
              </div>
            </div>
          </div>

          <!-- Sidebar Menu -->
          <nav class="mt-2">
            <ul
              class="nav nav-pills nav-sidebar flex-column"
              data-widget="treeview"
              role="menu"
              data-accordion="false"
            >
              <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
              <li class="nav-item menu-open">
                <a href="#" class="nav-link">
                  <i class="nav-icon fas fa-tachometer-alt"></i>
                  <p>
                    Menu
                    <i class="right fas fa-angle-left"></i>
                  </p>
                </a>
                <ul class="nav nav-treeview">
                  <li class="nav-item">
                    <a href="contact.html" class="nav-link active">
                      <i class="far fa-circle nav-icon"></i>
                      <p>Contact</p>
                    </a>
                  </li>
                </ul>
              </li>
            </ul>
          </nav>
          <!-- /.sidebar-menu -->
        </div>
        <!-- /.sidebar -->
      </aside>

      <!-- Content Wrapper. Contains page content -->
      <div class="content-wrapper">
        <!-- Content Header (Page header) -->
        <section class="content-header">
          <div class="container-fluid">
            <div class="row mb-2">
              <div class="col-sm-6">
                <h1>Contact</h1>
              </div>
              <div class="col-sm-6">
                <ol class="breadcrumb float-sm-right">
                  <li class="breadcrumb-item"><a href="#">Home</a></li>
                  <li class="breadcrumb-item active">Contact</li>
                </ol>
              </div>
            </div>
          </div>
          <!-- /.container-fluid -->
        </section>

        <!-- Main content -->
        <section class="content">
          <!-- Vùng header -->
          <div class="container">
            <div class="text-center">
              <h2 class="mt-2">Danh Sách Người Dùng Đăng Ký</h2>
            </div>
            <div class="form-group">
              <button class="btn btn-success" id="btn-create-contact-user">
                <i class="fa fa-plus"></i>&nbsp; Thêm user
              </button>
            </div>
          </div>
          <!-- Register User Table -->
          <div class="container">
            <table
              class="table table-bordered table-striped table-hover"
              id="contact-user-table"
            >
              <thead>
                <tr>
                  <th class="text-center">id</th>
                  <th class="text-center">Name</th>
                  <th class="text-center">Email</th>
                  <th class="text-center">Message</th>
                  <th class="text-center">Date</th>
                  <th class="col-2 text-center">Action</th>
                </tr>
              </thead>
            </table>
          </div>
          <!-- Vùng Modal -->

          <!-- Create contact User modal -->
          <div>
            <div
              id="create-contact-user-modal"
              class="modal fade"
              tabindex="-1"
            >
              <div class="modal-dialog">
                <div class="modal-content">
                  <div class="modal-header">
                    <h5 class="modal-title" id="h5-modal-title">Thêm User</h5>
                    <button class="close" data-dismiss="modal">&times;</button>
                  </div>
                  <div class="modal-body">
                    <form>
                      <div class="row form-group">
                        <div class="col-sm-4">
                          <label for="inp-create-name">Name</label>
                        </div>
                        <div class="col-sm-8">
                          <input
                            type="text"
                            id="inp-create-name"
                            name="firstname"
                            class="form-control"
                          />
                        </div>
                      </div>
                      <div class="row form-group">
                        <div class="col-sm-4">
                          <label for="inp-create-email">Email</label>
                        </div>
                        <div class="col-sm-8">
                          <input
                            type="text"
                            id="inp-create-email"
                            name="lastname"
                            class="form-control"
                          />
                        </div>
                      </div>
                      <div class="row form-group">
                        <div class="col-sm-4">
                          <label for="inp-create-message">Message</label>
                        </div>
                        <div class="col-sm-8">
                          <input
                            type="text"
                            id="inp-create-message"
                            name="subject"
                            class="form-control"
                          />
                        </div>
                      </div>
                      <div class="row form-group">
                        <div class="col-sm-4">
                          <label for="inp-create-date">CreateDate</label>
                        </div>
                        <div class="col-sm-8">
                          <div
                            class="input-group date"
                            id="reservationdate"
                            data-target-input="nearest"
                          >
                            <input
                              type="text"
                              class="form-control datetimepicker-input"
                              data-target="#reservationdate"
                            />
                            <div
                              class="input-group-append"
                              data-target="#reservationdate"
                              data-toggle="datetimepicker"
                            >
                              <div class="input-group-text">
                                <i class="fa fa-calendar"></i>
                              </div>
                            </div>
                          </div>
                        </div>
                      </div>
                    </form>
                  </div>
                  <div class="modal-footer">
                    <button
                      class="btn btn-secondary"
                      id="btn-create-cancel-register-user-modal"
                      data-dismiss="modal"
                    >
                      Cancel
                    </button>
                    <button
                      class="btn btn-primary"
                      id="btn-create-register-user-modal"
                    >
                      Thêm User
                    </button>
                  </div>
                </div>
              </div>
            </div>
          </div>
          <!-- Update Register User modal -->
          <div id="update-contact-user-modal" class="modal fade" tabindex="-1">
            <div class="modal-dialog">
              <div class="modal-content">
                <div class="modal-header">
                  <h5 class="modal-title" id="h5-modal-title">Cập nhật User</h5>
                  <button class="close" data-dismiss="modal">&times;</button>
                </div>
                <div class="modal-body">
                  <form>
                    <div class="row form-group">
                      <div class="col-sm-4">
                        <label for="inp-update-name">name</label>
                      </div>
                      <div class="col-sm-8">
                        <input
                          type="text"
                          id="inp-update-name"
                          name="firstname"
                          class="form-control"
                        />
                      </div>
                    </div>
                    <div class="row form-group">
                      <div class="col-sm-4">
                        <label for="inp-update-email">email</label>
                      </div>
                      <div class="col-sm-8">
                        <input
                          type="text"
                          id="inp-update-email"
                          name="lastname"
                          class="form-control"
                        />
                      </div>
                    </div>
                    <div class="row form-group">
                      <div class="col-sm-4">
                        <label for="inp-update-message">message</label>
                      </div>
                      <div class="col-sm-8">
                        <input
                          type="text"
                          id="inp-update-message"
                          name="subject"
                          class="form-control"
                        />
                      </div>
                    </div>
                    <div class="row form-group">
                      <div class="col-sm-4">
                        <label for="inp-create-date">CreateDate</label>
                      </div>
                      <div class="col-sm-8">
                        <div
                          class="input-group date"
                          id="reservationdate"
                          data-target-input="nearest"
                        >
                          <input
                            type="text"
                            class="form-control datetimepicker-input"
                            data-target="#reservationdate"
                          />
                          <div
                            class="input-group-append"
                            data-target="#reservationdate"
                            data-toggle="datetimepicker"
                          >
                            <div class="input-group-text">
                              <i class="fa fa-calendar"></i>
                            </div>
                          </div>
                        </div>
                      </div>
                    </div>
                  </form>
                </div>
                <div class="modal-footer">
                  <button
                    class="btn btn-info"
                    id="btn-update-cancel-contact-user-modal"
                    data-dismiss="modal"
                  >
                    Cancel
                  </button>
                  <button
                    class="btn btn-success"
                    id="btn-update-contact-user-modal"
                  >
                    Update User
                  </button>
                </div>
              </div>
            </div>
          </div>
          <!-- Delete Register User modal -->
          <div>
            <div class="modal fade" tabindex="-1" id="delete-confirm-modal">
              <div class="modal-dialog">
                <div class="modal-content">
                  <div class="modal-header">
                    <h5 class="modal-title" id="h5-modal-title">
                      Confirm xóa user
                    </h5>
                    <button class="close" data-dismiss="modal">&times;</button>
                  </div>
                  <div class="modal-body">
                    <label>Bạn có chắc chắn muốn xóa voucher này không?</label>
                  </div>
                  <div class="modal-footer">
                    <button class="btn btn-danger" id="btn-confirm-delete-user">
                      Xác nhận
                    </button>
                    <button class="btn btn-secondary" data-dismiss="modal">
                      Hủy bỏ
                    </button>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </section>
        <!-- /.content -->
      </div>
      <!-- /.content-wrapper -->

      <footer class="main-footer">
        <div class="float-right d-none d-sm-block"><b>Version</b> 3.2.0</div>
        <strong
          >Copyright &copy; 2014-2021
          <a href="https://adminlte.io">AdminLTE.io</a>.</strong
        >
        All rights reserved.
      </footer>

      <!-- Control Sidebar -->
      <aside class="control-sidebar control-sidebar-dark">
        <!-- Control sidebar content goes here -->
      </aside>
      <!-- /.control-sidebar -->
    </div>
    <!-- ./wrapper -->

    <!-- jQuery -->
    <script src="plugins/jquery/jquery.min.js"></script>
    <!-- Bootstrap 4 -->
    <script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
    <!-- AdminLTE App -->
    <script src="dist/js/adminlte.min.js"></script>
    <!-- date-range-picker -->
    <script src="plugins/moment/moment.min.js"></script>
    <script src="plugins/daterangepicker/daterangepicker.js"></script>
    <!-- bootstrap color picker -->
    <script src="plugins/bootstrap-colorpicker/js/bootstrap-colorpicker.min.js"></script>
    <!-- AdminLTE for demo purposes -->
    <!-- Data Table-->

    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <script src="https://cdn.datatables.net/1.13.5/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.13.5/js/dataTables.bootstrap4.min.js"></script>
    <script>
      //Date picker
      $("#inp-create-Date").datetimepicker({
        format: "L",
      });
    </script>
    <script>
      var gContactUserID = 0;

      const gBASE_URL = "https://62442d9d3da3ac772b0c50eb.mockapi.io/api/v1";
      const gCONTENT_TYPE = "application/json;charset=UTF-8";

      // Biến mảng hằng số chứa danh sách tên các thuộc tính
      const gCONTACT_USER_COLS = [
        "id",
        "name",
        "email",
        "message",
        "createDate",
        "action",
      ];

      // Biến mảng toàn cục định nghĩa chỉ số các cột tương ứng
      const gCONTACT_ID_COL = 0;
      const gCONTACT_NAME_COL = 1;
      const gCONTACT_EMAIL_COL = 2;
      const gCONTACT_MESSAGE_COL = 3;
      const gCONTACT_DATE = 4;
      const gCONTACT_USER_ACTION_COL = 5;

      // Khai báo DataTable & mapping collumns
      var gContactUserTable = $("#contact-user-table").DataTable({
        columns: [
          { data: gCONTACT_USER_COLS[gCONTACT_ID_COL] },
          { data: gCONTACT_USER_COLS[gCONTACT_NAME_COL] },
          { data: gCONTACT_USER_COLS[gCONTACT_EMAIL_COL] },
          { data: gCONTACT_USER_COLS[gCONTACT_MESSAGE_COL] },
          { data: gCONTACT_USER_COLS[gCONTACT_DATE] },
          { data: gCONTACT_USER_COLS[gCONTACT_USER_ACTION_COL] },
        ],
        columnDefs: [
          {
            // định nghĩa lại cột action
            targets: gCONTACT_USER_ACTION_COL, // cột Action
            className: "action-column", // định nghĩa thêm thuộc tính cho cột Action để các phần tử trong nó không
            defaultContent: `
        <button class='btn btn-primary btn-edit-contact-user'> Sửa </button> <button class='btn btn-danger btn-delete-contact-user'> Xóa </button>
      `,
          },
        ],
      });
      $(document).ready(function () {
        // thực hiện tải trang
        onPageLoading();

        // 2 - C: gán sự kiện Create - Thêm mới 1 register user
        $("#btn-create-contact-user").on("click", function () {
          onBtnAddNewContactUserClick();
        });

        // 3 - U: gán sự kiện Update - Sửa 1 register user
        $("#contact-user-table").on(
          "click",
          ".btn-edit-contact-user",
          function () {
            onBtnEditContactUserClick(this);
          }
        );

        // // 4 - D: gán sự kiện Delete - Xóa 1 register user
        $("#contact-user-table").on(
          "click",
          ".btn-delete-contact-user",
          function () {
            onBtnDeleteContactUserClick(this);
          }
        );

        // // gán sự kiện cho nút Thêm User (trên modal)
        $("#btn-create-register-user-modal").on("click", function () {
          onBtnCreateContactUserModalClick();
        });

        // // gán sự kiện cho nút Update User (trên modal)
        $("#btn-update-contact-user-modal").on("click", function () {
          onBtnUpdateContactUserModalClick();
        });
        // // gán sự kiện cho nút Xác nhận khi modal xóa user hiện lên
        $("#btn-confirm-delete-user").on("click", function () {
          onBtnDeleteExistingUserModalClick();
        });
        function onPageLoading() {
          // 1 - R: Read / Load all users
          getAllContactUser();
        }
        // Hàm xử lý sự kiện khi nút Thêm mới đc click
        function onBtnAddNewContactUserClick() {
          // hiển thị modal trắng lên
          $("#create-contact-user-modal").modal("show");
        }
        // Hàm xử lý sự kiện khi button edit Sửa trên bảng đc click
        function onBtnEditContactUserClick(paramBtnEdit) {
          // lưu thông tin registerUserId đang được edit vào biến toàn cục
          gContactUserID = getContactUserIdFromButton(paramBtnEdit);
          console.log(
            `%cId của contact User khi ấn nút Sửa: ${gContactUserID}`,
            `color: blue`
          );
          // load dữ liệu vào các trường dữ liệu trong modal
          getRegisteredUserById(gContactUserID);
          // hiển thị modal lên
          $("#update-contact-user-modal").modal("show");
        }
        // Hàm xử lý sự kiện khi button Xóa trên bảng đc click
        function onBtnDeleteContactUserClick(paramBtnDelete) {
          // lưu thông tin registerUserId đang được xóa vào biến toàn cục
          gContactUserID = getContactUserIdFromButton(paramBtnDelete);
          console.log(
            `%cId của COntact User khi ấn nút Xóa: ${gContactUserID}`,
            `color: red`
          );
          // hiển thị modal delete lên
          $("#delete-confirm-modal").modal("show");
        }

        // hàm xử lý sự kiện delete Existing User modal click
        function onBtnDeleteExistingUserModalClick() {
          // 1. Thu thập dữ liệu (bỏ qua)
          // 2. Validate dữ liệu (bỏ qua)
          // 3. Xóa User đang tồn tại bằng cách gọi server (API)
          $.ajax({
            url: gBASE_URL + "/contacts/" + gContactUserID,
            type: "DELETE",
            success: function (paramRegisteredUser) {
              handleDeleteExistingUserSuccess(paramRegisteredUser);
            },
            error: function (paramErr) {
              console.log(paramErr.status);
            },
          });
        }
        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình */
        // hàm gọi api để lấy all danh sách user đăng ký (Register Users)
        function getAllContactUser() {
          $.ajax({
            url: gBASE_URL + "/contacts",
            type: "GET",
            success: function (paramContactUsers) {
              // ghi được Response ra console
              console.log(Object.entries(paramContactUsers));
              loadDataToRegisterUserTable(paramContactUsers);
            },
            error: function (paramErr) {
              console.log(paramErr.status);
            },
          });
        }
        /** load contact user array to DataTable
         * in: contact user array
         * out: contact user table has data
         */
        function loadDataToRegisterUserTable(paramContactUsers) {
          gContactUserTable.clear();
          gContactUserTable.rows.add(paramContactUsers);
          gContactUserTable.draw();
        }
        // hàm get contact user by user id
        function getRegisteredUserById(paramContactUserId) {
          $.ajax({
            url: gBASE_URL + "/contacts/" + paramContactUserId,
            type: "GET",
            success: function (paramContactedUser) {
              showContactedUserDateToModal(paramContactedUser);
            },
            error: function (paramErr) {
              console.log(paramErr.status);
            },
          });
        }
        // hàm dựa vào button detail (edit or delete) xác định đc id register user
        function getContactUserIdFromButton(paramButton) {
          var vTableRow = $(paramButton).parents("tr");
          var vContactUserRowData = gContactUserTable.row(vTableRow).data();
          return vContactUserRowData.id;
        }
        // hàm thu thập dữ liệu để create register user
        function getCreateContactUserDateInput(paramContactUserObj) {
          paramContactUserObj.name = $("#inp-create-name").val().trim();
          paramContactUserObj.email = $("#inp-create-email").val().trim();
          paramContactUserObj.message = $("#inp-create-message").val().trim();
          // paramContactUserObj.createDate = $("#country-create-select").val().trim();
        }
        // hàm thu thập dữ liệu để update register user (khác logic và số field đối với trường hợp create)
        function getUpdateCurrentUserDataInput(paramContactUserObj) {
          paramContactUserObj.name = $("#inp-update-name").val().trim();
          paramContactUserObj.email = $("#inp-update-email").val().trim();
          paramContactUserObj.message = $("#inp-update-message").val().trim();
          // paramContactUserObj.country = $("#country-update-select").val().trim()
        }
        // hàm validate Create User data
        function validateCountactUserDateUnpit(paramContactuser) {
          // hàm này dùng chung cho Create và Update
          var vIsValid = true;
          if (paramContactuser.name === "") {
            alert("name phải được nhập");
            vIsValid = false;
          }
          if (paramContactuser.email === "") {
            alert("email phải được nhập");
            vIsValid = false;
          }
          if (paramContactuser.message === "") {
            alert("message phải được nhập");
            vIsValid = false;
          }
          // if(paramContactuser.createDate === "") {
          //   alert("Bạn phải chọn một ngay");
          //   vIsValid = false;
          // }
          return vIsValid;
        }

        // hàm xử lý sự kiện create Register User modal click
        function onBtnCreateContactUserModalClick() {
          // khai báo đối tượng chứa register user data
          var vRegisterUser = {
            name: "",
            email: "",
            message: "",
            createDate: "",
          };
          // B1: Thu thập dữ liệu
          getCreateContactUserDateInput(vRegisterUser);
          // B2: Validate insert
          var vIsValid = validateCountactUserDateUnpit(vRegisterUser);
          if (vIsValid) {
            // B3: Thêm mới User
            $.ajax({
              url: gBASE_URL + "contacts/",
              type: "POST",
              contentType: gCONTENT_TYPE,
              data: JSON.stringify(vRegisterUser),
              success: function (paramResponse) {
                // B4: xử lý front-end
                handleCreateContactUserSuccess();
              },
              error: function (paramErr) {
                console.log(paramErr.status);
              },
            });
          }
        }
        // hàm load dữ liệu User đang tồn tại lên Modal theo UserId
        function showContactedUserDateToModal(paramContactedUser) {
          // gán nội dung đối tượng User cho các thẻ input thông qua value
          $("#inp-update-name").val(paramContactedUser.name);
          $("#inp-update-email").val(paramContactedUser.email);
          $("#inp-update-message").val(paramContactedUser.message);
          $(".datetimepicker-input").val(paramContactedUser.createDate);

          /* gán nội dung đối tượng User cho các thẻ select
      - .option để chọn tất cả thẻ option bên trong thẻ select
      - dùng filter() để lọc các option và giữ lại những option có nội dung text bằng với giá trị của thuộc tính
      - hàm callback function() trả về true cho các option thỏa điều kiện
      - sử dụng prop('selected', true) để đăt thuộc tính selected của option tìm thấy thành true, làm lựa chọn mặc định trong thẻ select
    */
        }
        // hàm xử lý sự kiện update Register User modal click
        function onBtnUpdateContactUserModalClick() {
          // khai báo đối tượng chứa register user data
          var vRegisterUser = {
            firstname: "",
            lastname: "",
            subject: "",
            country: "",
            customerType: "",
            registerStatus: "",
          };
          // B1: Thu thập dữ liệu
          getUpdateCurrentUserDataInput(vRegisterUser);
          // B2: validate insert (update User)
          var vIsValid = validateCountactUserDateUnpit(vRegisterUser);
          if (vIsValid) {
            // B3: Cập nhật thông tin User bằng gọi server (API)
            $.ajax({
              url: gBASE_URL + "/contacts/" + gContactUserID,
              type: "PUT",
              contentType: gCONTENT_TYPE,
              data: JSON.stringify(vRegisterUser),
              success: function (paramResponse) {
                // B4: xử lý front-end
                handleUpdateCurrentUserSuccess();
              },
              error: function (paramErr) {
                console.log(paramErr.status);
              },
            });
          }
        }
        // hàm xử lý hiển thị thông báo và dữ liệu trên front-end khi thêm Register User thành công
        function handleCreateContactUserSuccess() {
          alert("Thêm Register User thành công!");
          getAllContactUser();
          resertContactUserModalForm();
          $("#create-contact-user-modal").modal("hide");
        }
        // hàm xử lý hiển thị thông báo và dữ liệu trên front-end khi thêm Register User thành công
        function handleUpdateCurrentUserSuccess() {
          alert("Cập nhật Current User thành công!");
          getAllContactUser();
          resertContactUserModalForm();
          $("#update-contact-user-modal").modal("hide");
        }
        // hàm xử lý hiển thị thông báo cho người dùng biết đã xóa User thành công
        function handleDeleteExistingUserSuccess() {
          alert("Đã xóa User thành công!");
          getAllContactUser();
          $("#delete-confirm-modal").modal("hide");
        }
        // hàm xóa trắng form Create và Update Register User (dùng chung)
        function resertContactUserModalForm() {
          $("#inp-update-name").val("");
          $("#inp-update-email").val("");
          $("#inp-update-message").val("");
          $("#inp-update-date").val("");
        }
      });
    </script>
  </body>
</html>
